#include <stdio.h>
#include <stdlib.h>

struct atomo {
       int dato;
       struct atomo *next;
       };
       
void visualizza(struct atomo *tl)
{
     if(tl!=NULL)
      {
        /* visualizza il primo elemento*/
        printf("%d\n",tl->dato);
        visualizza(tl->next);
      }
}

void in_lista(struct atomo **tl, int x) 
{
     struct atomo *a;
     a=(struct atomo *) malloc(sizeof(struct atomo));
     if(a==NULL) return;
     a->dato=x;
     a->next=*tl;
     *tl=a;
}

void ins_ord(struct atomo **tl, int x)
{
     if(*tl==NULL|| x < (*tl)->dato)
       in_lista(tl,x);
     else ins_ord(&(*tl)->next,x);
}

void da_lista(struct atomo **tl)
{
     struct atomo *aux;
     /* invocare solo avere verifcato che 
     la lista non e' vuota*/
     
     aux=*tl;
     *tl=aux->next;
     free(aux);
}

void elimina(struct atomo **tl, int x)
{
   if(*tl==NULL)
      return;
     if((*tl)->dato==x)
      /* eliminiamo dalla testa */
       da_lista(tl);
     else elimina(&(*tl)->next,x);
}

main() {
       struct atomo *tl;
       tl=NULL;
       int i,x;
       
       for(i=0;i<5;i++)
        {
         printf("Num: ");
         scanf("%d",&x);
         ins_ord(&tl,x);
        }
       visualizza(tl);
       
       printf("Num da eliminare: ");
       scanf("%d",&x);
       elimina(&tl,x);
       visualizza(tl);
       
       while(tl!=NULL)
          da_lista(&tl);
          
       getch();
}  
     
       
